GNU Radio C++ API Reference: gr::trellis::interleaver Class Reference

| GNU Radio C++ API Reference 3.10.12.0 The Free & Open Software Radio Ecosystem |

Loading...
Searching...
No Matches
gr::trellis::interleaver Class Reference
GNU Radio C++ Signal Processing Blocks » Trellis Coding

INTERLEAVER class. More...

`#include <gnuradio/trellis/interleaver.h>`

## Public Member Functions
| interleaver ()
| construct empty interleaver
| interleaver (const interleaver &interleaver)
| copy constructor
| interleaver (unsigned int k, const std::vector< int > &interleaver)
| construct interleaver with redundant vector length parameter
| interleaver (const std::vector< int > &interleaver)
| construct interleaver from index vector
| interleaver (const char *name)
| construct interleaver from file
| interleaver (unsigned int k, int seed)
| construct random interleaver
unsigned int | k () const
| return length of interleaver
const std::vector< int > & | interleaver_indices () const
| return interleaver index vector reference
const std::vector< int > & | deinterleaver_indices () const
| return deinterleaver index vector reference
unsigned int | K () const
| return length of interleaver
const std::vector< int > & | INTER () const
| return interleaver index vector reference
const std::vector< int > & | DEINTER () const
| return deinterleaver index vector reference
void | write_interleaver_txt (std::string filename)
| write interleaver index vector to text file

## Detailed Description

INTERLEAVER class.

## Constructor & Destructor Documentation

## ◆ interleaver() [1/6]

gr::trellis::interleaver::interleaver | ( |  | ) |

construct empty interleaver

Referenced by interleaver(), interleaver(), and interleaver().

## ◆ interleaver() [2/6]

gr::trellis::interleaver::interleaver | ( | const interleaver & | interleaver | ) |

copy constructor

References interleaver().

## ◆ interleaver() [3/6]

gr::trellis::interleaver::interleaver | ( | unsigned int | k,
|  | const std::vector< int > & | interleaver )

construct interleaver with redundant vector length parameter

Parameters

  k | vector length
  interleaver | index vector

References interleaver(), and k().

## ◆ interleaver() [4/6]

gr::trellis::interleaver::interleaver | ( | const std::vector< int > & | interleaver | ) |

construct interleaver from index vector

Parameters

  interleaver | index vector

References interleaver().

## ◆ interleaver() [5/6]

gr::trellis::interleaver::interleaver | ( | const char * | name | ) |

construct interleaver from file

File format is ASCII, `{number of interleaver taps} {empty line} {K space-separated list: permutation of 0 1 2 … K-1} {optional comments}`

Parameters

  name | file containing interleaver specification

## ◆ interleaver() [6/6]

gr::trellis::interleaver::interleaver | ( | unsigned int | k,
|  | int | seed )

construct random interleaver

Parameters

  k | length
  seed | seed for PRNG

References k().

## Member Function Documentation

## ◆ DEINTER()

const std::vector< int > & gr::trellis::interleaver::DEINTER | ( |  | ) | const
| inline

return deinterleaver index vector reference

## ◆ deinterleaver_indices()

const std::vector< int > & gr::trellis::interleaver::deinterleaver_indices | ( |  | ) | const
| inline

return deinterleaver index vector reference

## ◆ INTER()

const std::vector< int > & gr::trellis::interleaver::INTER | ( |  | ) | const
| inline

return interleaver index vector reference

## ◆ interleaver_indices()

const std::vector< int > & gr::trellis::interleaver::interleaver_indices | ( |  | ) | const
| inline

return interleaver index vector reference

## ◆ K()

unsigned int gr::trellis::interleaver::K | ( |  | ) | const
| inline

return length of interleaver

## ◆ k()

unsigned int gr::trellis::interleaver::k | ( |  | ) | const
| inline

return length of interleaver

Referenced by interleaver(), and interleaver().

## ◆ write_interleaver_txt()

void gr::trellis::interleaver::write_interleaver_txt | ( | std::string | filename | ) |

write interleaver index vector to text file

See also
  gr::trellis::interleaver::interleaver(const char* name)

The documentation for this class was generated from the following file:

- interleaver.h